# ExtraEnemyCustomization (Version 1.x.x)
```
DISCLAIMER: This MOD is meant to be used by Rundown Developer to make their own enemy in ease. It's NOT a client-end MOD.
```

# ***[Use this Reference Config to learn how to use this MOD](https://github.com/GTFO-Modding/ExtraEnemyCustomization/raw/master/wikifiles/EEC_1.0/ExtraEnemyCustomization.zip)***
Un-zip them to your `YourRundownFolder/Custom/ExtraEnemyCustomization` path

# 1.6.0 Patch Note
 + Added: `Model.jsonc/AnimHandleCustom` - Allows to directly edit animation timing values or punch scream sfx
 + Fixed Issue: Scout Tentacles with custom distance won't visible in certain angle
 + Performance Improvement
   - BonePrefabs are now no longer happens on Spawned but PrefabBuilt
   - ShooterDistSettingHandler now works as coroutine

# 1.5.0 Patch Note
 + Added: `ProjectileDefinition/LifeTime`
 + Added: `ProjectileDefinition/SpawnProjectileOn[CollideWorld/CollidePlayer/LifeTimeDone]`
 + Added: `EnemyAbility.jsonc/LimbDestroyedAbilityCustom`
 + Added: `EnemyAbility.jsonc/SpawnProjectileAbility`
 + Fixed Issue: GlowCustom Pulse effect with variable duration won't show properly
 + Fixed Issue: `Item Count was below 2!`
 + Fixed Issue: Deprecated Configs now won't show warnings `SpawnCost.json`

# 1.4.4 Patch Note
 + (For Plugin Devs) Base Namespace change (Old `EECustom` -> `EEC`)
 + Huge Performance Improvement
   - Improved Spawn Performance
   - Optimized StateReplicator Performance
   - Flyer Check Component now only applied to fliers
 + Removed `Performance.LazySpawnedEvent` option

# 1.4.3 Patch Note
 + Just a README update, reverting deprecate of ProjectileDefinitions Abilities

# 1.4.2 Patch Note
 + Fixed Issue: Bleeding Custom Text now shows properly

# 1.4.1 Patch Note
 + Fixed Issue: EMP now clear their state between checkpoints properly
 + Fixed Issue: DoorBreaker timer now reset their timer between checkpoints

# 1.4.0 Patch Note
 + Added: `Property.jsonc/DistantRoarCustom` - Play Distant roar sound you want when agressive enemy has spawned
 + Added: `~AttackCustom/ProjectileData` - Now Projectile Special Ability Also supported in AttackCustoms
 + Added: `ProjectileDefenitions/InitialHoming~ + HomingDelay` - Projectile Advanced Homing options
 + Added: `ProjectileDefenitions/Trail[Color-Width-Time]` - Projectile Trail effect modification
 + Added: `FogSphereCustom/[Color-Intensity-Range-...]Curve` - Editing FogSphere Properties based on new Animation Curve System
 + Added: `BleedAttackCustom/OverrideBleedingTextID` - Option to change Bleeding Text based on TextDataBlock ID
 + Added: `Explosion[AttakCustom/Ability]/LightColor` - Option to change LightFlash color of explosion
 + Fixed Issue: DoorBreakerCustom could break the door breaking system
 + FIxed Issue: TryGetEnemyMarkerSpriteRenderer Unhollower warning
 + Fixed Issue: Partial fix for Explosion Ability won't affect level objects (Lock, Door etc)

# 1.3.1 Patch Note
 + Added: User Config - `Marker Text` `Marker Distance` `Explosion Flash`
 + Updated BepInEx Config format - now using `EEC.cfg` file
 + Fixed Issue: Several Bug Fixes with ScannerCustom

# 1.3.0 Patch Note
 + Added: `BoneCustom/Prefabs` - Attach Whatever prefab you want to Bone
 + Added: `MarkerCustom/MarkerText` - Show customizable texts for Marker with formatting
 + Added: `MarkerCustom/ShowDistance` - Show Distance Indicator for Marker
 + Added: `Bleed[AttackCustom/Projectile]/CanBeStacked` - Set Bleeding setting to be stacked infinitely without overwriting existing one
 + Added: `ProjectileDefinitions/StaminaDrain` - Drain Stamina when got hit by projectile
 + Added: `ProjectileDefinitions/SpeedChange` - Change Projectile speed over time
 + Added: `ProjectileDefinitions/HomingStrengthChange` - Change Projectile homing strength over time
 + Performance Improvement: Bleeding now works smoother
 + Performance Improvement: Few Networking stuff has improved to send packet to target only
 + Fixed Issue: Bleeding now can display blood effect even when players are downed


# Supported Features
 + ## Model Customization
    - `ShadowCustom`: Shadow Varient Customization (For every enemy model)
    - `MaterialCustom`: Material Swapper for changing skin of emenies
    - `GlowCustom`: for edting color of enemy glowing in general, also provide feature to adding custom Pulse Effect
    - `LimbCustom`: Enemy Limb Health/Weak/ArmorSpot Customization
    - `MarkerCustom`: Bio-tracker Ping Icon/Behaviour Customization (with custom images / texts)
    - `ModelRefCustom`: ModelReference Custom for editing Bio-Tracker Ping position/Shooter Firing Position/Striker Tentacle Position
    - `ScannerCustom`: Bio-tracker screen customization per enemies (with real-time color changes)
    - `SilhouetteCustom`: Provides enemies silhouette to be able to see through the wall
    - `BoneCustom`: Powerful setting to change each enemy's bodypart scale/position/rotation or Add your own Prefab to it

 + ## Ability Customization
    - `FogSphereCustom`: Fog Sphere Ability's Fog Setting
    - `BirthingCustom`: Birthing Ability Customization
    - `HealthRegenCustom`: for Health Regen/Decay Enemy
    - `InfectionAttackCustom`: for Infectious Tentacle/Punch/Projectile
    - `ExplosiveAttackCustom`: for Explosive Tentacle/Punch/Projectile
    - `KnockbackAttackCustom`: for adding knockback for Tentacle/Punch/Projectile
    - `BleedAttackCustom`: for adding bleeding effect for Tentacle/Punch/Projectile
    - `DrainStaminaAttackCustom`: for draining victim's stamina
    - `DoorBreakerCustom`: DoorBreaker Ability Speed/Damage Customization
    - `ScoutScreamingCustom`: Change Scout Screaming GlowColor and FogColor along with Infectious FogSphere

 + ## EnemyAbility Customization
    - `BehaviourAbilityCustom`: Trigger Ability based on Cooldown, Distance, LOS, State
    - `DeathAbilityCustom`: Trigger Ability when enemies death triggered

    * ### Supported Abilities
       - `DoAnim`
       - `FogSphere`
       - `Explosion`
       - `SpawnEnemy`
       - `SpawnWave`
       - `EMP`
       - `Cloak`
       - `Chain`: Trigger multiple ability at once!

 + ## Striker Tentacle Customization
    - `StrikerTentacleCustom`
       - Striker Tentacle Model Type Customization
       - Striker Tentacle In/Out/Stay time Custom
    - `TentacleDefinitions`
       - Work in Progress

 + ## Shooter Firing Customization
    - `ShooterFireCustom`
       - Shooter Projectile Setting Custom
       - Distance based Projectile Setting Swapper
    - `ProjectileDefinitions`
       - Custom Shooter Projectile Editing
       - Explosive Projectile `[Use ExplosiveAttackCustom if possible]`
       - Knockback Projectile `[Use KnockbackAttackCustom if possible]`
       - Bleeding Projectile `[Use BleedAttackCustom if possible]`
       - Infectious Projectile `[Use InfectionAttackCustom if possible]`
       - StaminaDrain Projectile `[Use DrainStaminaAttackCustom if possible]`

 + ## Detection Customization
    - `FeelerCustom`: Scout Feeler Count/Color/Distance Customization
    - `ScoutAnimCustom`: Customizable Scout Feeler Animation

 + ## Scout Wave Customization
    - Different wave setting per Scout Variants
    - StopOnDead Setting for Scout alive orientated constant alarm
    - Random Picker for having different wave setting for single variant

 + ## Property Customization
    - `SpawnCostCustom`: You can edit Enemy's spawncost without editing population settings
    - `EventsCustom`: Trigger WardenObjectiveEvent!
       - OnSpawnedEvent
       - OnWakeupEvent
       - OnDeadEvent
       - Triggering OnBossDeathEvent!
    - `DistantRoarCustom`: Play sound you wanted when specific wave enemies has spawned

 + ## Miscellaneous Things
    - LiveEdit: Edit your config without reboot the game
    - Healer Enemies support: Negative Damage will now heal players
    - Global Config: Flyer Stuck Check

 + ## Partial Data Integration
    - You can use GUID to any enemy persistentID field if you using PartialData!


# Credits
 - peelz: Setup for future MTFO update
 - mccad00: Enemy Marker icons
 - Kasuromi: Providing codes related to SpawnCost / Helping me lot with PR review
 - Dex: Providing codes related to SilhouetteCustom
 - dakkhuza: Helping with implementing EMP / Providing codes related to Explosion